VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   6540
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8805
   LinkTopic       =   "Form1"
   ScaleHeight     =   6540
   ScaleWidth      =   8805
   StartUpPosition =   3  'Windows-Standard
   Begin VB.OptionButton Option1 
      Caption         =   "StretchBlt (lahm)"
      Height          =   315
      Index           =   1
      Left            =   4620
      TabIndex        =   8
      Top             =   5100
      Width           =   3735
   End
   Begin VB.OptionButton Option1 
      Caption         =   "PaintPicture"
      Height          =   315
      Index           =   0
      Left            =   4620
      TabIndex        =   7
      Top             =   4740
      Value           =   -1  'True
      Width           =   3735
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   3420
      Max             =   10
      Min             =   1
      TabIndex        =   4
      Top             =   60
      Value           =   1
      Width           =   1215
   End
   Begin VB.Timer tmrAnimation 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   5760
      Top             =   0
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   4215
      Left            =   4620
      ScaleHeight     =   277
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   247
      TabIndex        =   2
      Top             =   480
      Width           =   3765
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   5055
      Left            =   120
      ScaleHeight     =   333
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   289
      TabIndex        =   3
      Top             =   480
      Width           =   4395
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   60
      Width           =   1275
   End
   Begin VB.Timer tmrFPS 
      Interval        =   1000
      Left            =   1800
      Top             =   0
   End
   Begin VB.Label Label2 
      Caption         =   "Je hher das Intervall ist, desto aktueller ist der Wert, aber dieser ist nicht immer genau."
      Height          =   735
      Left            =   120
      TabIndex        =   6
      Top             =   5580
      Width           =   4395
   End
   Begin VB.Label Label1 
      Caption         =   "Intervall"
      Height          =   195
      Left            =   2580
      TabIndex        =   5
      Top             =   60
      Width           =   795
   End
   Begin VB.Label lblFPS 
      Caption         =   "-1"
      Height          =   255
      Left            =   1440
      TabIndex        =   0
      Top             =   60
      Width           =   1035
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Code von Benjamin Wilger
' Benjamin@ActiveVB.de
' Copyright (C) 2001
Option Explicit

Private Declare Function StretchBlt Lib "gdi32" ( _
                         ByVal hdc As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal nWidth As Long, _
                         ByVal nHeight As Long, _
                         ByVal hSrcDC As Long, _
                         ByVal xSrc As Long, _
                         ByVal ySrc As Long, _
                         ByVal nSrcWidth As Long, _
                         ByVal nSrcHeight As Long, _
                         ByVal dwRop As Long) As Long
                         
Private FCount As Long ' Anzahl der Frames
Private FPS As Double

Private Sub Form_Load()

    Picture1.Picture = LoadPicture(App.Path & "\billborg.jpg")
    
End Sub

Private Sub tmrFPS_Timer()

    FPS = FCount / (tmrFPS.Interval / 1000) ' Die Frames auf das
                                            ' Timer-Intervall 1000
                                            ' umrechnen
    FCount = 0 ' Anzahl der Frames auf Null zurckstellen um eine neue
               ' Messung zu starten
    lblFPS.Caption = "FPS: " & Round(FPS, 2) ' Ausgeben
    
End Sub

Private Sub HScroll1_Change()

    tmrFPS.Interval = 1000 / HScroll1.Value
    
End Sub

Private Sub Command1_Click()

    tmrAnimation.Enabled = Not tmrAnimation.Enabled ' Timer schalten(ON/OFF)
    
End Sub

Private Sub tmrAnimation_Timer()

    Static Position As Long
    Static theta As Double, adder1 As Long, adder2 As Long
    
    Dim Pi As Double
    
    Pi = Atn(1) * 4
    theta = theta + Pi / 16
    
    If theta > 2 * Pi Then theta = 0
    
    ' Hier wird zum Testen der FPS eine einfache Animation gemacht
    Position = Position + 5
    
    If Position > Picture2.ScaleWidth Then
    
        Position = -Picture1.ScaleWidth
        
    End If
    
    adder1 = 25 * Sin(theta)
    adder2 = 25 * Cos(theta)
    Picture2.Cls
    
    If Option1(0).Value Then
    
        Picture2.PaintPicture Picture1.Picture, Position + adder1, ( _
            Picture2.ScaleHeight - Picture1.ScaleHeight) / 2 + adder1, _
            Picture1.ScaleWidth + adder2, Picture1.ScaleHeight + adder2
            
    Else
    
        StretchBlt Picture2.hdc, Position + adder1, (Picture2.ScaleHeight - _
            Picture1.ScaleHeight) / 2 + adder1, Picture1.ScaleWidth + _
            adder2, Picture1.ScaleHeight + adder2, Picture1.hdc, 0, 0, _
            Picture1.ScaleWidth, Picture1.ScaleHeight, vbSrcCopy
            
    End If
    
    Picture2.Refresh
    FCount = FCount + 1 ' Hier den FrameCount erhhen.
    
End Sub

